if RFconfig==1
  Rn=Exp(expN).Dexp(DexpN).RFmean; Rs=Exp(expN).Dexp(DexpN).RFstd;
end

if RFconfig==2
  ctrlRF=cell2mat(answer(anN(1)))
  switch ctrlRF
    case {'G','g'}
      Rn(1)=Exp(expN).Dexp(DexpN).RFmeanG(DM0);
      Rs(1)=Exp(expN).Dexp(DexpN).RFstdG(DM0);
    case {'L','l'}
      if Exp(expN).Dexp(DexpN).meanP(DMj,m)~=0    
        Rn(1)=Exp(expN).Dexp(DexpN).meanP(DN0,m);
        Rs(1)=Exp(expN).Dexp(DexpN).stdP(DM0,m);
      elseif Exp(expN).Dexp(DexpN).meanP(DMj,m)==0||isempty(Exp(expN).Dexp(DexpN).meanP(DMj,m)) &&...
          strcmpi(ctrlRF,'G')
          Rn(1)=Exp(expN).Dexp(DexpN).RFmeanG(DM0);
          Rs(1)=Exp(expN).Dexp(DexpN).RFstdG(DM0);
      end
  end
  pertRF=cell2mat(answer(anN(2)))
  switch pertRF
    case {'G','g'}
      Rn(2:dmN)=Exp(expN).Dexp(DexpN).RFmeanG(2:end);
      Rs(2:dmN)=Exp(expN).Dexp(DexpN).RFstdG(2:end);
    case {'L','l'}
      if Exp(expN).Dexp(DexpN).meanP(DMj,m)~=0    
        Rn(j)=Exp(expN).Dexp(DexpN).meanP(DMj,m);
        Rs(j)=Exp(expN).Dexp(DexpN).stdP(DMj,m);
      elseif Exp(expN).Dexp(DexpN).meanP(DMj,m)==0||isempty(Exp(expN).Dexp(DexpN).meanP(DMj,m)) &&...
        strcmpi(ctrlRF,'G')
        Rn(j)=Exp(expN).Dexp(DexpN).RFmeanG(DMj);
        Rs(j)=Exp(expN).Dexp(DexpN).RFstdG(DMj);
      end
  end
end

if RFconfig==3
  ctrlRF=cell2mat(answer(anN(1)))
  switch ctrlRF
    case {'F','f'}
      Rn(1)=Exp(expN).Dexp(DexpN).RFmean(DM0);
      Rs(1)=Exp(expN).Dexp(DexpN).RFstd(DM0);
    case {'G','g'}
      Rn(1)=Exp(expN).Dexp(DexpN).RFmeanG(DM0);
      Rs(1)=Exp(expN).Dexp(DexpN).RFstdG(DM0);
    case {'L','l'}
      Rn(1)=Exp(expN).Dexp(DexpN).meanP(DM0,m);
      Rs(1)=Exp(expN).Dexp(DexpN).stdP(DM0,m);
      if Exp(expN).Dexp(DexpN).meanP(DMj,m)~=0,    
        Rn(1)=Exp(expN).Dexp(DexpN).meanP(DM0,m);
        Rs(1)=Exp(expN).Dexp(DexpN).stdP(DM0,m);
      elseif Exp(expN).Dexp(DexpN).meanP(DM0,m)==0 && strcmpi(ctrlRF,'G')
        Rn(1)=Exp(expN).Dexp(DexpN).RFmeanG(DM0);
        Rs(1)=Exp(expN).Dexp(DexpN).RFstdG(DMj);
      elseif Exp(expN).Dexp(DexpN).meanP(DM0,m)==0 && strcmpi(ctrlRF,'F')
        Rn(1)=Exp(expN).Dexp(DexpN).RFmean(DM0);
        Rs(1)=Exp(expN).Dexp(DexpN).RFstd(DM0);
      elseif Exp(expN).Dexp(DexpN).meanP(DM0,m)==0 && strcmpi(ctrlRF,'L')
        Rn(1)=Exp(expN).Dexp(DexpN).RFmeanG(DM0);
        Rs(1)=Exp(expN).Dexp(DexpN).RFstdG(DM0);   
      end
  end
  pertRF=cell2mat(answer(anN(2)))
  switch pertRF
    case {'F','f'}
      Rn(2:dmN)=Exp(expN).Dexp(DexpN).RFmean(2:end);
      Rs(2:dmN)=Exp(expN).Dexp(DexpN).RFstd(2:end);
    case {'G','g'}
      Rn(2:dmN)=Exp(expN).Dexp(DexpN).RFmeanG(2:end);
      Rs(2:dmN)=Exp(expN).Dexp(DexpN).RFstdG(2:end);
    case {'L','l'}
      if Exp(expN).Dexp(DexpN).meanP(DMj,m)~=0,    
        Rn(j)=Exp(expN).Dexp(DexpN).meanP(DMj,m);
        Rs(j)=Exp(expN).Dexp(DexpN).stdP(DMj,m);
      elseif Exp(expN).Dexp(DexpN).meanP(DMj,m)==0 && strcmpi(ctrlRF,'G')
        Rn(j)=Exp(expN).Dexp(DexpN).RFmeanG(DMj);
        Rs(j)=Exp(expN).Dexp(DexpN).RFstdG(DMj);
      elseif Exp(expN).Dexp(DexpN).meanP(DMj,m)==0 && strcmpi(ctrlRF,'F')
        Rn(j)=Exp(expN).Dexp(DexpN).RFmean(DMj);
        Rs(j)=Exp(expN).Dexp(DexpN).RFstd(DMj);
      elseif Exp(expN).Dexp(DexpN).meanP(DMj,m)==0 && strcmpi(ctrlRF,'L')
        Rn(j)=Exp(expN).Dexp(DexpN).RFmeanG(DMj);
        Rs(j)=Exp(expN).Dexp(DexpN).RFstdG(DMj);   
      end
  end
end