%EZdestConp.m  GraphicDestinationPertibationComparison**15_821
%Produces Trend plots across perturbation (DrugMedia) plates
%Called by EZvDatatip.m and EZlstBoxExt.m 
%Provides Trace data storage for use by EZfigTrendOL.m

if lstBoxCmpFlg==1
 Exp(zoneSel).seltraceN=traceN;
 seltraceN=traceN;   
end
if expN==1 && get(ghandles.CompositeTog1,'value')==1 ||... 
   expN==2 && get(ghandles.CompositeTog2,'value')==1 ||...     
   expN==3 && get(ghandles.CompositeTog3,'value')==1 
  CompositeTrendFlg=1; else CompositeTrendFlg=0;
end

destPerMP=Exp(expN).Dexp(DexpN).destPerMP;
if EZdatatip==1  %adaptation for image spot selection
  % plNums=plateNum;
  % destPerMP=Exp(expN).Dexp(DexpN).destPerMP;
  plNums=(MPsel-1)*destPerMP + (1:destPerMP)
  zoneSel=expN;
  tracN=Exp(zoneSel).traceN;
  if zoneSel==1,Dlaxes=ghandles.Dlaxes1;Dkaxes=ghandles.Dkaxes1;Draxes=ghandles.Draxes1; end
  if zoneSel==2,Dlaxes=ghandles.Dlaxes2;Dkaxes=ghandles.Dkaxes2;Draxes=ghandles.Draxes2; end
  if zoneSel==3,Dlaxes=ghandles.Dlaxes3;Dkaxes=ghandles.Dkaxes3;Draxes=ghandles.Draxes3; end
  if zoneSel==1,DNLaxes=ghandles.DNLaxes1;end
  if zoneSel==2,DNLaxes=ghandles.DNLaxes2;end
  if zoneSel==3,DNLaxes=ghandles.DNLaxes3;end 
elseif EZdatatip==2  % adaption for Overlay plot selection
  % destPerMP=Exp(expN).Dexp(DexpN).destPerMP;
  MPlateN=ceil(OLplateNum/destPerMP);
  plNums=(MPlateN-1)*destPerMP + (1:destPerMP);
  zoneSel=expN;
  tracN=Exp(zoneSel).traceN;
  if zoneSel==1,Dlaxes=ghandles.Dlaxes1;Dkaxes=ghandles.Dkaxes1;Draxes=ghandles.Draxes1; end
  if zoneSel==2,Dlaxes=ghandles.Dlaxes2;Dkaxes=ghandles.Dkaxes2;Draxes=ghandles.Draxes2; end
  if zoneSel==3,Dlaxes=ghandles.Dlaxes3;Dkaxes=ghandles.Dkaxes3;Draxes=ghandles.Draxes3; end
  if zoneSel==1,DNLaxes=ghandles.DNLaxes1;end  %2016_0222
  if zoneSel==2,DNLaxes=ghandles.DNLaxes2;end %2016_0222
  if zoneSel==3,DNLaxes=ghandles.DNLaxes3;end %2016_0222
elseif EZdatatip==0
  if lstBoxCmpFlg~=1
    DexpN=Exp(expN).DexpN;
    plNums=(LBmp-1)*destPerMP + (1:destPerMP);
    tracN=Exp(zoneSel).traceN;
    Exp(expN).Trace(traceN).DexpN=DexpN;
  elseif lstBoxCmpFlg==1
    DexpN=Exp(expN).DexpN;
    tracN=Exp(zoneSel).traceN;
  end  
  % determin if selection is a User chosen RF-****-mdG or RF-****-mdP
  Lbl=cell2mat(selGnOrf);
  if ~isempty(strfind(Lbl,'RF')) && ~isempty(strfind(Lbl,'md')) 
    strLoc=strfind(Lbl,'md');
    MPloc=strfind(Lbl,':');
    dMP=str2double(Lbl((MPloc(1)+1):(MPloc(2)-1)));
    if strcmp(Lbl(strLoc:strLoc+3),'-mdG(');
      RFmdFlg='mdG';
    elseif strcmp(Lbl(strLoc:strLoc+3),'-mdP(')
      RFmdFlg='mdP';  
    elseif strcmp(Lbl(strLoc:strLoc+2),'md(')
      RFmdFlg='md';  
    end
  end
    
  if zoneSel==1,DNLaxes=ghandles.DNLaxes1;end  %2016_0222
  if zoneSel==2,DNLaxes=ghandles.DNLaxes2;end  %2016_0222
  if zoneSel==3,DNLaxes=ghandles.DNLaxes3;end  %2016_0222
end  % if EZdatatip==1  %adaptation for image spot selection

if EZdatatip==2  % Response to Overlay click
  % seltraceN comes from EZvDatatip; 
  % Exp(OLay).seltraceN iscaptured from EZvDatatip
  % if an OLay trace is selected 
  % else it is captured below if EZdatatip is not equal to 2

  try
    set(Exp(zoneSel).hLRF1(seltraceN),'visible','on'); set(Exp(zoneSel).hLRF2(seltraceN),'visible','on');
  catch, end
  try
    set(Exp(zoneSel).hL(seltraceN),'visible','on'); set(Exp(zoneSel).hLb(seltraceN),'visible','on'); 
  catch, end

  % Plot new intL  
  try 
    set(Exp(zoneSel).hintL(seltraceN),'visible','on'); set(Exp(zoneSel).hintLb(seltraceN),'visible','on'); 
  catch, end
  try
    set(Exp(zoneSel).hintLadj(seltraceN),'visible','on'); set(Exp(zoneSel).hintLadjb(seltraceN),'visible','on');  
  catch, end
  if zoneSel==1,set(ghandles.DNLaxes1,'xlim',[-75,75]); end

  for J=1:(tracN)
    try    
    set(Exp(zoneSel).hKRF1(J),'visible','off'); set(Exp(zoneSel).hKRF2(J),'visible','off');
    catch, end
    try
    set(Exp(zoneSel).hK(J),'visible','off'); set(Exp(zoneSel).hKb(J),'visible','off'); 
    catch, end
    end
    try
    set(Exp(zoneSel).hKRF1(seltraceN),'visible','on'); set(Exp(zoneSel).hKRF2(seltraceN),'visible','on');
    catch, end
    try
    set(Exp(zoneSel).hK(seltraceN),'visible','on'); set(Exp(zoneSel).hKb(seltraceN),'visible','on'); 
    catch, end

    for J=1:(tracN),
    try    
    set(Exp(zoneSel).hrRF1(J),'visible','off'); set(Exp(zoneSel).hrRF2(J),'visible','off');
    catch, end
    try
    set(Exp(zoneSel).hr(J),'visible','off'); set(Exp(zoneSel).hrb(J),'visible','off'); 
    catch, end
  end
  try
  set(Exp(zoneSel).hrRF1(seltraceN),'visible','on'); set(Exp(zoneSel).hrRF2(seltraceN),'visible','on');
  catch, end
  try
  set(Exp(zoneSel).hr(seltraceN),'visible','on'); set(Exp(zoneSel).hrb(seltraceN),'visible','on'); 
  catch, end
else
  % Plot RFmd1 and RFmd2 indexes
  if EZdatatip==0
  end
  %if ~exist(RFmdFlg)
  RF1mdIndx=Exp(zoneSel).Dexp(DexpN).RFmd1indx;
  RF1mdPltN=Exp(zoneSel).Dexp(DexpN).RFmd1pltN;
  RF2mdIndx=Exp(zoneSel).Dexp(DexpN).RFmd2indx;
  RF2mdPltN=Exp(zoneSel).Dexp(DexpN).RFmd2pltN;
  try Rn=Exp(expN).Dexp(DexpN).RFmean; catch, Rn=0; end
  try Rs=Exp(expN).Dexp(DexpN).RFstd; catch, Rs=0; end
  if isempty(RF1mdIndx)
    try Rn=Exp(expN).Dexp(DexpN).RFmeanG; catch, Rn=0; end
    try Rs=Exp(expN).Dexp(DexpN).RFstdG; catch, Rs=0; end
  end


  if lstBoxCmpFlg~=1
    Exp(zoneSel).seltraceN=tracN;
    seltraceN=tracN;   
  end
  % Plot L K r for all pertibation(destination) Plates
  if lstBoxCmpFlg~=1 % If selection is a "normal" item with a location in the label
    try RF1mdNums=(RF1mdPltN-1)*destPerMP + (1:destPerMP); catch, end   %RF1mdPltN  %
    try RF2mdNums=(RF2mdPltN-1)*destPerMP + (1:destPerMP); catch, end %RF2mdPltN  %
    for I=1:length(plNums), 
      if CompositeTrendFlg==0 || EZdatatip==1 %'Normal' gene/orf spot image or listbox item with location data
        Exp(expN).Trace(traceN).dmSel=pertSel;
        Exp(expN).Trace(traceN).DexpN=DexpN;
        Exp(expN).Trace(traceN).UsrGLB=selGnOrf;   %usrGnSp;
        if ~exist('RFmdFlg')
          lvals(I)=scan(1,plNums(I)).plate(1).CFout(indx,5);
          if lvals(I)==0, lvals(I)=140; end
          kvals(I)=scan(1,plNums(I)).plate(1).CFout(indx,3);
          rvals(I)=scan(1,plNums(I)).plate(1).CFout(indx,4);
          Exp(expN).Trace(tracN).Dexp(DexpN).DM(I).UsrLvals=lvals(I);
          Exp(expN).Trace(tracN).Dexp(DexpN).DM(I).UsrKvals=kvals(I);
          Exp(expN).Trace(tracN).Dexp(DexpN).DM(I).Usrrvals=rvals(I);
        elseif strcmp(RFmdFlg,'mdG')
          lvals(I)=Exp(expN).Dexp(DexpN).RFcmpGL.dm(I).med;
          if lvals(I)==0, lvals(I)=140; end
          kvals(I)=Exp(expN).Dexp(DexpN).RFcmpGK.dm(I).med;
          rvals(I)=Exp(expN).Dexp(DexpN).RFcmpGr.dm(I).med;
          Exp(expN).Trace(tracN).Dexp(DexpN).DM(I).UsrLvals=lvals(I);
          Exp(expN).Trace(tracN).Dexp(DexpN).DM(I).UsrKvals=kvals(I);
          Exp(expN).Trace(tracN).Dexp(DexpN).DM(I).Usrrvals=rvals(I);
        elseif strcmp(RFmdFlg,'mdP')
          lvals(I)=Exp(expN).Dexp(DexpN).RFmedianP(I,dMP);
          if lvals(I)==0, lvals(I)=140; end
          kvals(I)=scan(1,plNums(I)).plate(1).CFout(indx,3);  %No P med.Kvals /dms currently avail.
          rvals(I)=scan(1,plNums(I)).plate(1).CFout(indx,4);  %No P med.rvals /dms currently avail.
          Exp(expN).Trace(tracN).Dexp(DexpN).DM(I).UsrLvals=lvals(I);
          Exp(expN).Trace(tracN).Dexp(DexpN).DM(I).UsrKvals=kvals(I);
          Exp(expN).Trace(tracN).Dexp(DexpN).DM(I).Usrrvals=rvals(I);
        elseif strcmp(RFmdFlg,'md')
          lvals(I)=Exp(expN).Dexp(DexpN).RFmean(I);
          if lvals(I)==0, lvals(I)=140; end
          kvals(I)=scan(1,plNums(I)).plate(1).CFout(indx,3); %No P med.Kvals /dms currently avail.
          rvals(I)=scan(1,plNums(I)).plate(1).CFout(indx,4); %No P med.rvals /dms currently avail.
          Exp(expN).Trace(tracN).Dexp(DexpN).DM(I).UsrLvals=lvals(I);
          Exp(expN).Trace(tracN).Dexp(DexpN).DM(I).UsrKvals=kvals(I);
          Exp(expN).Trace(tracN).Dexp(DexpN).DM(I).Usrrvals=rvals(I);      
        end
      elseif CompositeTrendFlg==1 && EZdatatip==0 %Gene-Specifics Composite from listBox 
        lvals(I)=median(cell2mat(Exp(expN).Trace(tracN).Dexp(DexpN).DM(I).UsrLvals));
        if lvals(I)==0, lvals(I)=140; end
        kvals(I)=median(cell2mat(Exp(expN).Trace(tracN).Dexp(DexpN).DM(I).UsrKvals));
        rvals(I)=median(cell2mat(Exp(expN).Trace(tracN).Dexp(DexpN).DM(I).Usrrvals));
      end
      try
        if ~isempty(RF1mdIndx)    
          lvalsRF1md(I)=scan(1,RF1mdNums(I)).plate(1).CFout(RF1mdIndx(I),5);
          if lvalsRF1md(I)==0, lvalsRF1md(I)=140; end
          kvalsRF1md(I)=scan(1,RF1mdNums(I)).plate(1).CFout(RF1mdIndx(I),3);
          rvalsRF1md(I)=scan(1,RF1mdNums(I)).plate(1).CFout(RF1mdIndx(I),4); 
        elseif ~isempty(Exp(expN).Dexp(DexpN).RFcmpGL.dm(I).med)
          lvalsRF1md(I)=Exp(expN).Dexp(DexpN).RFcmpGL.dm(I).med;
          if lvalsRF1md(I)==0, lvalsRF1md(I)=140; end
          kvalsRF1md(I)=Exp(expN).Dexp(DexpN).RFcmpGK.dm(I).med;
          rvalsRF1md(I)=Exp(expN).Dexp(DexpN).RFcmpGr.dm(I).med; 
        end     
      catch
      end         
      try
        lvalsRF2md(I)=scan(1,RF2mdNums(I)).plate(1).CFout(RF2mdIndx(I),5);
        if lvalsRF2md(I)==0, lvalsRF2md(I)=140; end
        kvalsRF2md(I)=scan(1,RF2mdNums(I)).plate(1).CFout(RF2mdIndx(I),3);
        rvalsRF2md(I)=scan(1,RF2mdNums(I)).plate(1).CFout(RF2mdIndx(I),4);
      catch
      end            
      % Added for INTERACTION Calculating Utility 2016_0219
      try
        if CompositeTrendFlg==0 || EZdatatip==1
          Xn(I)=Exp(expN).Dexp(DexpN).scan(plNums(I)).plate(1).CFout(indx,5);
          Xln(I)=Exp(expN).Dexp(DexpN).scan(plNums(I)).plate(1).CFout(indx,11);
          Xhn(I)=Exp(expN).Dexp(DexpN).scan(plNums(I)).plate(1).CFout(indx,12);
        elseif CompositeTrendFlg==1 && EZdatatip~=1
          Xn(I)=median(cell2mat(Exp(expN).Trace(tracN).Dexp(DexpN).DM(I).UsrLvals));
          Xln(I)=Xn(I) - std(cell2mat(Exp(expN).Trace(tracN).Dexp(DexpN).DM(I).UsrLvals));
          Xhn(I)=Xn(I) + std(cell2mat(Exp(expN).Trace(tracN).Dexp(DexpN).DM(I).UsrLvals));
        end
        if Xn(I)==0, deltaXR(I)=140; end
        if isnan(Xhn(I))||isnan(Xln(I))|| Xhn(I)==0||Xln(I)==0||isnan(Rs(I))
          deltaXR(I)=140;  
        elseif Xn(I) >=Rn(I) 
          deltaXR(I)=Xln(I)-(Rn(I)+Rs(I));
        else
          deltaXR(I)=Xhn(I)-(Rn(I)-Rs(I)); 
        end    
      catch
        msg='No Refs! ->No Interaction Calculations!'       
      end
    end
  elseif lstBoxCmpFlg==1  %Determine values of RF1cmp or RFcmpG or RFcmpP composites
    for dm=1:destPerMP
      if RFcmpGFlg==0  %RF1cmp or RF2cmp clicked
        lvals(dm)=Exp(expN).Dexp(DexpN).RFcmpL(RFnum).dm(dm).med;
        if lvals(dm)==0, lvals(dm)=140; end
        kvals(dm)=Exp(expN).Dexp(DexpN).RFcmpK(RFnum).dm(dm).med;
        rvals(dm)=Exp(expN).Dexp(DexpN).RFcmpr(RFnum).dm(dm).med; 
      elseif RFcmpGFlg==1
        lvals(dm)=Exp(expN).Dexp(DexpN).RFcmpGL.dm(inDM).med;% Ls=num2str(l);
        if lvals(dm)==0, lvals(dm)=140; end
        kvals(dm)=Exp(expN).Dexp(DexpN).RFcmpGK.dm(inDM).med; %Ks=num2str(K);
        rvals(dm)=Exp(expN).Dexp(DexpN).RFcmpGr.dm(inDM).med; %rs=num2str(r);
      end
      % Added for INTERACTION Calculating Utility 2016_0219
      try
        Xn(dm)=lvals(dm);
        Xln(dm)=lvals(dm)- Exp(expN).Dexp(DexpN).RFcmpL(RFnum).dm(inDM).std ;
        Xhn(dm)=lvals(dm)+ Exp(expN).Dexp(DexpN).RFcmpL(RFnum).dm(inDM).std;
        if Xn(dm)==0, deltaXR(dm)=140; end
        if isnan(Xhn(dm))||isnan(Xln(dm))|| Xhn(dm)==0||Xln(dm)==0||isnan(Rs(dm))
          deltaXR(dm)=140;  
        elseif Xn(dm) >=Rn(dm) 
          deltaXR(dm)=Xln(dm)-(Rn(dm)+Rs(dm));
        else
          deltaXR(dm)=Xhn(dm)-(Rn(dm)-Rs(dm)); 
        end      
      catch
        msg='No Refs! ->No Interaction Calculations!'       
      end
    end % for dm=1:destPerMP  
    Exp(expN).Trace(traceN).UsrGLB=selGnOrf; %Added 18_0118 for tickLabelStr issue in EZfigTrendOL.m assoc'd with RFcmpG(-)
  end

  % INTERACTION Plotting Utility 2016_021             
  try   
    if Rn(1)==0 % if Ref mean is zero
      intL=0; proGrIntL=0; intLadj=0; proGrIntLadj=0; 
      intNormL=6.66;intNormLadj=6.66; proGrIntNormL=6.66;proGrIntNormLadj=6.66;
    else
      % if Xn(I)==0 || Xn(I)==140,intL =140; else  intL=(Xn-Rn); end
      intL=(Xn-Rn);
      intL(Xn==0)=140;
      intLadj=(deltaXR);
      Exp(expN).Trace(tracN).Dexp(DexpN).UsrIntL=intL;
      %{
      intNormL=(intL) ./ Rn(1)
      intNormLadj=((deltaXR)./ Rn(1))
      proGrIntL=-(intL) 
      proGrIntLadj=-(deltaXR)
      proGrIntNormL=-(intL ./ Rn(1))
      proGrIntNormLadj=-((deltaXR)./ Rn(1))
      %find where Xn(j)==0 and set interactL to a fixed Max interaction value
      intNormL(find(Xn==0))=2
      intNormLadj(find(Xn==0))=2
      proGrIntLadj(find(Xn==0))=-2
      proGrIntNormLadj(find(Xn==0))=-2 
      %}    
    end
  catch
    FailMessage='Problem with Reference Rn value; Unable to produce Interaction values! Ln119 EZdestComp'
  end
    
  hidem(ghandles.Daxes1) 
  if zoneSel==1,showm(ghandles.Dlaxes1);showm(ghandles.Dkaxes1);showm(ghandles.Draxes1);end
  if zoneSel==2,showm(ghandles.Dlaxes2);showm(ghandles.Dkaxes2);showm(ghandles.Draxes2);end
  if zoneSel==3,showm(ghandles.Dlaxes3);showm(ghandles.Dkaxes3);showm(ghandles.Draxes3);end
  set(Dlaxes,'NextPlot','add'); set(Dkaxes,'NextPlot','add'); set(Draxes,'NextPlot','add')
  if zoneSel==1,showm(ghandles.DNLaxes1); end
  if zoneSel==2,showm(ghandles.DNLaxes2); end
  if zoneSel==3,showm(ghandles.DNLaxes3); end
  set(DNLaxes,'NextPlot','add');    
  % Make visible the current L plot and store it for retrieval by OLay code
  if verLessThan('matlab','8.4')
  else  % accomodate new matlab changes after 2014a fix  23_0807
    tempFig2=figure;
  end
  try % some experiments do not have ref. plates 
    Exp(zoneSel).hLRF1(tracN)=plot(Dlaxes,lvalsRF1md,1:destPerMP,'b'); hold on
  catch
  end
  try
    Exp(zoneSel).hLRF2(tracN)=plot(Dlaxes,lvalsRF2md,1:destPerMP,'c'); hold on
  catch
  end  
  try
    Exp(zoneSel).hL(tracN)=plot(Dlaxes,lvals,1:destPerMP); Exp(zoneSel).hLb(tracN)=plot(Dlaxes,lvals,1:destPerMP,'rs');
  catch
  end
  if zoneSel==1,set(ghandles.Dlaxes1,'xlim',[0,140]); end
  if zoneSel==2,set(ghandles.Dlaxes2,'xlim',[0,140]); end
  if zoneSel==3,set(ghandles.Dlaxes3,'xlim',[0,140]); end
  % Make visible Plot for Interaction Data, Store and Hide unless a N (InteractionPBsel) set that plot on Top of the RawData Plots.
  % Plot new intL  
  try 
    % zeroCLn=zeros(1,destPerMP)
    % Exp(zoneSel).hzeroCLn=plot(DNLaxes,zeroCLn,1:destPerMP,'y');
    Exp(zoneSel).hintL(tracN)=plot(DNLaxes,intL,1:destPerMP); Exp(zoneSel).hintLb(tracN)=plot(DNLaxes,intL,1:destPerMP,'rs');
    Exp(zoneSel).hintLadj(tracN)=plot(DNLaxes,intLadj,1:destPerMP,'g'); Exp(zoneSel).hintLadjb(tracN)=plot(DNLaxes,intLadj,1:destPerMP,'gs');
  catch
  end
  if zoneSel==1,set(ghandles.DNLaxes1,'xlim',[-75,75]); end
  if zoneSel==2,set(ghandles.DNLaxes2,'xlim',[-75,75]); end
  if zoneSel==3,set(ghandles.DNLaxes3,'xlim',[-75,75]); end
 
  % intNormL
  % intNormLadj
  % ProGrIntLadj Plot
  % ProGrintLadj Plot 
  % ProGrintNormL
  % proGrintNormLadj
  % Hide all K  plots
           
  for J=1:(tracN-1),
    try
      set(Exp(zoneSel).hKRF1(J),'visible','off');  set(Exp(zoneSel).hKRF2(J),'visible','off');
    catch
    end
    try 
      set(Exp(zoneSel).hK(J),'visible','off');  set(Exp(zoneSel).hKb(J),'visible','off'); 
    catch
    end  
  end

  % Make visible the current L plot and store it for retrieval by OLay code
  try % some experiments do not have ref. plates
    Exp(zoneSel).hKRF1(tracN)=plot(Dkaxes,kvalsRF1md,1:destPerMP,'b'); 
    Exp(zoneSel).hKRF2(tracN)=plot(Dkaxes,kvalsRF2md,1:destPerMP,'c');
  catch
  end
  try
    Exp(zoneSel).hK(tracN)=plot(Dkaxes,kvals,1:destPerMP,'b'); Exp(zoneSel).hKb(tracN)=plot(Dkaxes,kvals,1:destPerMP,'rs');
  catch
  end
  set(Dkaxes,'xlim',[0,200]) % max(kvals+20)
  set(Dkaxes,'ycolor',[.9,.9,1])

  % Hide all r plots
  for J=1:(tracN-1),
    try
      set(Exp(zoneSel).hrRF1(J),'visible','off');  set(Exp(zoneSel).hrRF2(J),'visible','off');
    catch, end
    try 
      set(Exp(zoneSel).hr(J),'visible','off');  set(Exp(zoneSel).hrb(J),'visible','off'); 
    catch, end  
  end
  
  % Make visible the current r plot and store it for retrieval by OLay code
  try  %Some experiments do not have ref. plates
    Exp(zoneSel).hrRF1(tracN)=plot(Draxes,rvalsRF1md,1:destPerMP,'b');
    Exp(zoneSel).hrRF2(tracN)=plot(Draxes,rvalsRF2md,1:destPerMP,'c');
  catch, end
  try
    Exp(zoneSel).hr(tracN)=plot(Draxes,rvals,1:destPerMP,'b'); Exp(zoneSel).hrb(tracN)=plot(Draxes,rvals,1:destPerMP,'rs');
  catch, end
  set(Draxes,'xlim',[0,1])
  set(Draxes,'ycolor',[.9,.9,1])   
end

if zoneSel==1, set(ghandles.geneOrfLKr1,'string', grfgenestr);end 
if zoneSel==2, set(ghandles.geneOrfLKr2,'string', grfgenestr);end
if zoneSel==3, set(ghandles.geneOrfLKr3,'string', grfgenestr);end

% Display Selection PlotFilter
if Exp(4).interacPBsel==0
  % replace ghandles.DNLaxes1 (Dlaxes2)etc. with a single
  % Exp(zoneSel).DNLaxes,....
  set(ghandles.Dlaxes1,'Visible','on')
  set(ghandles.Dlaxes2,'Visible','on')
  set(ghandles.Dlaxes3,'Visible','on')
  set(ghandles.DNLaxes1,'Visible','off')
  set(ghandles.DNLaxes2,'Visible','off')
  set(ghandles.DNLaxes3,'Visible','off')
     
  for n=1:Exp(zoneSel).traceN
    try
      set(Exp(zoneSel).hLRF1(n),'visible','off');  set(Exp(zoneSel).hLRF2(n),'visible','off');
    catch, end
    try 
      set(Exp(zoneSel).hL(n),'visible','off');  set(Exp(zoneSel).hLb(n),'visible','off'); 
    catch, end  
    try
      set(Exp(zoneSel).hintL(n),'visible','off');  set(Exp(zoneSel).hintLb(n),'visible','off');
    catch, end
    try 
      set(Exp(zoneSel).hintLadj(n),'visible','off');  set(Exp(zoneSel).hintLadjb(n),'visible','off'); 
    catch, end  
  end
        
  try
    set(Exp(zoneSel).hLRF1(seltraceN),'visible','on');  set(Exp(zoneSel).hLRF2(seltraceN),'visible','on');
  catch, end
  try 
    set(Exp(zoneSel).hL(seltraceN),'visible','on');  set(Exp(zoneSel).hLb(seltraceN),'visible','on'); 
  catch, end  
  for i=1:Exp(zoneSel).expLoadCnt, 
    try set(Exp(zoneSel).hzeroCLn(i),'visible','off'); catch ME, end
  end
elseif Exp(4).interacPBsel==1
  set(ghandles.DNLaxes1,'Visible','on')
  set(ghandles.DNLaxes2,'Visible','on')
  set(ghandles.DNLaxes3,'Visible','on')
  set(ghandles.Dlaxes1,'Visible','off')
  set(ghandles.Dlaxes2,'Visible','off')
  set(ghandles.Dlaxes3,'Visible','off')
     
    
  for n=1:Exp(zoneSel).traceN
    try set(Exp(zoneSel).hLRF1(n),'visible','off'); catch, end
    try set(Exp(zoneSel).hLRF2(n),'visible','off'); catch, end
    try set(Exp(zoneSel).hL(n),'visible','off');  set(Exp(zoneSel).hLb(n),'visible','off'); catch, end  
    try set(Exp(zoneSel).hintL(n),'visible','off');  set(Exp(zoneSel).hintLb(n),'visible','off'); catch, end
    try set(Exp(zoneSel).hintLadj(n),'visible','off');  set(Exp(zoneSel).hintLadjb(n),'visible','off'); catch, end  
  end
  try set(Exp(zoneSel).hintL(seltraceN),'visible','on');  set(Exp(zoneSel).hintLb(seltraceN),'visible','on'); catch, end
  try set(Exp(zoneSel).hintLadj(seltraceN),'visible','on');  set(Exp(zoneSel).hintLadjb(seltraceN),'visible','on'); catch, end
  for i=1:Exp(zoneSel).expLoadCnt, 
    try set(Exp(zoneSel).hzeroCLn(i),'visible','on'); catch ME, end 
  end
elseif Exp(4).interacPBsel==2
end
   
if verLessThan('matlab','8.4')  
else  % accomodate new matlab changes after 2014a  fix update 23_0807
  close(tempFig2)
end


% Deprecated functions

%{
  for J=1:(tracN),
    try
      set(Exp(zoneSel).hintL(J),'visible','off');  set(Exp(zoneSel).hintLb(J),'visible','off');
    catch, end 
    try 
      set(Exp(zoneSel).hintLadj(J),'visible','off');  set(Exp(zoneSel).hintLadjb(J),'visible','off'); 
    catch, end  
  end
  %}
%{
  for J=1:(tracN),
    try    
    set(Exp(zoneSel).hLRF1(J),'visible','off'); set(Exp(zoneSel).hLRF2(J),'visible','off');
    catch, end
    try
    set(Exp(zoneSel).hL(J),'visible','off'); set(Exp(zoneSel).hLb(J),'visible','off'); 
    catch, end
  end
  %}

    %Hide all L plots
%{         
  for J=1:(tracN-1),
    try
      set(Exp(zoneSel).hLRF1(J),'visible','off');  set(Exp(zoneSel).hLRF2(J),'visible','off');
    catch, end
    try 
      set(Exp(zoneSel).hL(J),'visible','off');  set(Exp(zoneSel).hLb(J),'visible','off'); 
    catch, end  
  end
%}        
%Hide all intL plots
%{     
for J=1:(tracN),
  try
  set(Exp(zoneSel).hintL(J),'visible','off');  set(Exp(zoneSel).hintLb(J),'visible','off');
  catch, end 
  try 
  set(Exp(zoneSel).hintLadj(J),'visible','off');  set(Exp(zoneSel).hintLadjb(J),'visible','off'); 
  catch, end  
end
%}

    

% set(Dlaxes,'xlim',[0,max(lvals+20)])
% catch
  %     set(Dlaxes,'NextPlot','add');
  %    Exp(zoneSel).hL(tracN)=plot(Dlaxes,lvals,1:destPerMP); 
    %   Exp(zoneSel).hLb(tracN)=plot(Dlaxes,lvals,1:destPerMP,'rs');
      
      %hDaxL=plot(Dlaxes,lvals,1:destPerMP);hold(Dlaxes); plot(Dlaxes,lvals,1:destPerMP,'rs');...
        % hold(Dlaxes);
    %{   
    if max(lvals)>90
    set(Dlaxes,'xlim',[0,max(lvals+20)])
    else
    set(Dlaxes,'xlim',[0,90])
    end
    %}
      
  %end
  
  %{
  try
  hDaxK=plot(Dkaxes,kvalsRF1md,1:destPerMP,'y'); hold(Dkaxes); plot(Dkaxes,kvalsRF2md,1:destPerMP,'y');...
        plot(Dkaxes,kvals,1:destPerMP); plot(Dkaxes,kvals,1:destPerMP,'rs');...
        hold(Dkaxes);
    set(Dkaxes,'xlim',[0,200])  %max(kvals+20)
    set(Dkaxes,'ycolor',[.9,.9,1])
  catch
  set(Dkaxes,'NextPlot','replace');
  hDaxK=plot(Dkaxes,kvals,1:destPerMP); hold(Dkaxes); plot(Dkaxes,kvals,1:destPerMP,'rs');...
        hold(Dkaxes);
    set(Dkaxes,'xlim',[0,200])  %max(kvals+20)
    set(Dkaxes,'ycolor',[.9,.9,1])   
  end
  %}
  
    %{
  try
  hDaxR=plot(Draxes,rvalsRF1md,1:destPerMP,'y'); hold(Draxes); plot(Draxes,rvalsRF2md,1:destPerMP,'y');...
        plot(Draxes,rvals,1:destPerMP); plot(Draxes,rvals,1:destPerMP,'rs');... 
        hold(Draxes);
    set(Draxes,'xlim',[0,1])
    set(Draxes,'ycolor',[.9,.9,1])
  catch
  set(Draxes,'NextPlot','replace')   
  hDaxR=plot(Draxes,rvals,1:destPerMP); hold(Draxes); plot(Draxes,rvals,1:destPerMP,'rs');... 
          hold(Draxes);
    set(Draxes,'xlim',[0,1])
    set(Draxes,'ycolor',[.9,.9,1])   
  end
%}