% Diagnostic sheet called by EZvInitLoad.m, EZexpSel.m ?EZinteractDev_.m?
global Exp

intLfilename1=fullfile(Exp(expN).resDir,'PrintResults','!RFsDiagnostics.txt');
fid=fopen(RFdiagnostic,'w');
ln=1;
fprintf(fid,'%d\t',ln);
fprintf(fid,'%s\ExpName:::','Reference Diagnostic Values');

% Will need to reverse the equals pulling data from the Exp source as needed
% to populate the printout diagnostice sheet. 
for d=1:DMnum
  fprintf(fid,'RF Name\Median\Mean\STD\Max\Min');
  fprintf(fid,'\n')
  fprintf(fid,'\n')
  RFmd1pos= Exp(expN).RFmd1indx(d+1);
  RF1mp= Exp(expN).RFmd1pltN; 
  std1= Exp(expN).std1(:);
  mean1= Exp(expN).mean1(:); 
  min1= Exp(expN).min1(:);
  max1= Exp(expN).max1(:);
 
  RFmd2pos= Exp(expN).RFmd2indx(d+1);
  RF2mp= Exp(expN).RFmd2pltN;
  std2= Exp(expN).std2(d+1);
  mean2= Exp(expN).mean2(d+1);
  min2= Exp(expN).min2(d,dMPs(mm));
  max2= Exp(expN).max2(d,dMPs(mm));
  
  nzPosIndxDG= Exp(expN).RFmdGindx(d);
  dMP= Exp(expN).RFmdGpltN(d);
  rf1scNdisp= Exp(expN).RFmdGscanN(d);
  mvalsDGx= Exp(expN).RFmedianG(d);
  RFstdGx= Exp(expN).RFstdG(d);
  RFmeanGx= Exp(expN).RFmeanG(d); 
  RFmeanG=Exp(expN).minG(d,dMPs(mm));
  maxG= Exp(expN).maxG(d,dMPs(mm));
  minG= Exp(expN).minG(d,dMPs(mm));   
end
  
for mm=1:length(dMPs)
  for d=1:DMnum 
    RFmd1posD= Exp(expN).RFmdPindx(d,dMPs(mm));
    dMP= Exp(expN).RFmdPpltN(d,dMPs(mm));   % This is a storage of the MasterPlate used NOT the ScanPlate?  WeMight wish to store the ScanPlateNumber also???
    rf1scNdisp= Exp(expN).RFmdPscanN(d,dMPs(mm));
    mval1Disp= Exp(expN).RFmedianP(d,dMPs(mm));
    std1Disp= Exp(expN).stdP(d,dMPs(mm));
    mean1Disp= Exp(expN).meanP(d,dMPs(mm)); 
    minDisp= Exp(expN).minP(d,dMPs(mm));
    maxDisp= Exp(expN).maxP(d,dMPs(mm));
  end
end

%{
RFcombValList= cat(1,medValList1{d+1},medValList2{d+1});
rf12mean(RFcombValList)= Exp(expN).RFmean(d+1);
std12(RFcombValList)= Exp(expN).RFstd(d+1);
Exp(expN).RFmin(d+1)=min(RFcombValList);
Exp(expN).RFmax(d+1)=max(RFcombValList);
%}
  

fclose(fid)